SystemOrganization addCategory: #'SI-Benchmarks'!

AXAnnouncement subclass: #SignalBenchmarkAnnouncement
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkAnnouncement class methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:11:56.578'!
value: aValue

	^ self new value: aValue! !

!SignalBenchmarkAnnouncement methodsFor: 'accessing' stamp: 'mt 6/10/2010 18:07:58.242'!
value

	^ value! !

!SignalBenchmarkAnnouncement methodsFor: 'accessing' stamp: 'mt 6/10/2010 18:08:15.164'!
value: aValue

	value := aValue.! !

Object subclass: #SignalBenchmark
	instanceVariableNames: 'sender receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:32:50.338'!
run

	^ self new run! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:53:28.793'!
needsPreparation

	^ true! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:41:40.031'!
prepareOneBindingFor: aReceiver

	self subclassResponsibility.! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:18:41.446'!
receiverCount

	^ 10000! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:57:22.712'!
run

	| preparationTime triggeringTime |
	self setUp.
	
	self receiverCount timesRepeat: [
		(receivers add: SignalBenchmarkReceiver new)].
	
	preparationTime := self needsPreparation
		ifTrue: [ [receivers do: [:receiver | self prepareOneBindingFor: receiver]] timeToRunWithoutGC ]
		ifFalse: [0]..
	
	triggeringTime := [self triggerOneEventWith: 42] timeToRunWithoutGC.
	
	"Verify validity of results."
	receivers do: [:receiver | receiver checkValue: 42].
	
	self tearDown.
	^ self class -> {preparationTime. triggeringTime}! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:41:03.411'!
setUp

	sender := SignalBenchmarkSender new.
	receivers := OrderedCollection new.! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:10:43.249'!
tearDown

	sender := nil.
	receivers := nil.! !

!SignalBenchmark methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:44:39.496'!
triggerOneEventWith: aValue

	self subclassResponsibility.! !

SignalBenchmark subclass: #SignalBenchmarkAnnouncements
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkAnnouncements methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:02:59.378'!
initialize

	super initialize.
	announcer := AXAnnouncer new.! !

!SignalBenchmarkAnnouncements methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:15:46.584'!
prepareOneBindingFor: aReceiver

	announcer
		when: SignalBenchmarkAnnouncement
		do: [:announcement | aReceiver update: announcement value].
		! !

!SignalBenchmarkAnnouncements methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:12:50.9'!
triggerOneEventWith: aValue

	announcer announce: (SignalBenchmarkAnnouncement value: aValue).! !

SignalBenchmark subclass: #SignalBenchmarkManual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkManual methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:53:36.678'!
needsPreparation

	^ false! !

!SignalBenchmarkManual methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:50:19.755'!
prepareOneBindingFor: anObject

	"No bindings here."! !

!SignalBenchmarkManual methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:50:45.707'!
triggerOneEventWith: aValue

	receivers do: [:receiver | receiver update: aValue].! !

SignalBenchmark subclass: #SignalBenchmarkObjectDependents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkObjectDependents methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:42:00.976'!
prepareOneBindingFor: aReceiver

	sender addDependent: aReceiver.! !

!SignalBenchmarkObjectDependents methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:44:50.082'!
triggerOneEventWith: aValue

	sender changed: aValue. "Calls #update: in receivers."! !

SignalBenchmark subclass: #SignalBenchmarkObjectEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkObjectEvents methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:58:41.653'!
prepareOneBindingFor: aReceiver

	sender
		when: #valueChanged
		send: #update:
		to: aReceiver.! !

!SignalBenchmarkObjectEvents methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:59:23.643'!
triggerOneEventWith: aValue

	sender triggerEvent: #valueChanged with: aValue.! !

SignalBenchmark subclass: #SignalBenchmarkSignals
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkSignals methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:42:21.806'!
prepareOneBindingFor: aReceiver

	aReceiver
		connect: sender
		signal: #valueChanged:
		toSelector: #update:! !

!SignalBenchmarkSignals methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:45:00.615'!
triggerOneEventWith: aValue

	sender value: aValue. "Triggers #valueChanged:."! !

SignalBenchmarkSignals subclass: #SignalBenchmarkSignalsWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkSignalsWrapper methodsFor: 'as yet unclassified' stamp: 'mt 6/14/2010 22:30:39.73'!
prepareOneBindingFor: aReceiver

	aReceiver
		connect: sender
		signal: #value2:
		toSelector: #update:! !

!SignalBenchmarkSignalsWrapper methodsFor: 'as yet unclassified' stamp: 'mt 6/14/2010 22:40:32.945'!
triggerOneEventWith: aValue

	sender value2: aValue.! !

Object subclass: #SignalBenchmarkReceiver
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkReceiver methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:40:39.767'!
checkValue: expected

	value ~= expected ifTrue: [Error signal: 'Value check failed!!'].! !

!SignalBenchmarkReceiver methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:16:11.579'!
update: aValue

	value := aValue.! !

Object subclass: #SignalBenchmarkSender
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkSender methodsFor: 'accessing' stamp: 'mt 6/14/2010 22:30:09.622'!
value2: aValue
	"Use wrapped signals here."
! !

!SignalBenchmarkSender methodsFor: 'accessing' stamp: 'mt 6/10/2010 17:39:08.142'!
value: aValue

	self valueChanged: aValue.! !

!SignalBenchmarkSender methodsFor: 'signals' stamp: 'mt 6/10/2010 17:39:12.459'!
valueChanged: aValue

	 self emit.! !

Object subclass: #SignalBenchmarkSuite
	instanceVariableNames: 'results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SI-Benchmarks'!

!SignalBenchmarkSuite class methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:36:07.906'!
run

	^ self new run! !

!SignalBenchmarkSuite methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:36:35.728'!
initialize

	results := OrderedCollection new.! !

!SignalBenchmarkSuite methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 18:18:31.135'!
results

	^ results! !

!SignalBenchmarkSuite methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:37:16.754'!
run

	SignalBenchmark subclassesDo: [:benchmark |
		self run: benchmark].
	
	^ results! !

!SignalBenchmarkSuite methodsFor: 'as yet unclassified' stamp: 'mt 6/10/2010 17:37:01.093'!
run: aBenchmark

	^ results add: aBenchmark run! !
